/*
	Form.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSMatrix.h"

@interface NSForm : NSMatrix
{
}

+ setCellClass:factoryId;

- initFrame:(NSRect)frameRect;

- calcSize;
- setFrameSize:(NSSize)_newSize;
- sizeToFit;
- (int)selectedIndex;
- setEntryWidth:(float)width;
- setInterline:(float)spacing;
- setBordered:(BOOL)flag;
- setBezeled:(BOOL)flag;
- setTitleAlignment:(int)mode;
- setTextAlignment:(int)mode;
- setFont:fontObj;
- setTitleFont:fontObj;
- setTextFont:fontObj;
- drawCellAt:(int)index;
- (NSString *)titleAt:(int)index;
- setTitle:(NSString *)aString at:(int)index;
- addEntry:(NSString *)title;
- addEntry:(NSString *)title tag:(int)anInt target:anObject action:(SEL)aSelector;
- insertEntry:(NSString *)title at:(int)index;
- insertEntry:(NSString *)title at:(int)index tag:(int)anInt target:anObject action:(SEL)aSelector;
- removeEntryAt:(int)index;
- setTag:(int)anInt at:(int)index;
- setTarget:anObject at:(int)index;
- setAction:(SEL)aSelector at:(int)index;
- (int)findIndexWithTag:(int)aTag;
- (NSString *)stringValueAt:(int)index;
- setStringValue:(NSString *)aString at:(int)index;
- (int)intValueAt:(int)index;
- setIntValue:(int)anInt at:(int)index;
- (float)floatValueAt:(int)index;
- setFloatValue:(float)aFloat at:(int)index;
- (double)doubleValueAt:(int)index;
- setDoubleValue:(double)aDouble at:(int)index;
- selectTextAt:(int)index;

@end
