/*
 * NXSoundStream.h
 *
 * Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
 */

#import <objc/Object.h>
#import <sys/time.h>
#import <mach/mach.h>
#import "NXSoundDevice.h"
#import "NXSoundParameters.h"

// Obsolete, use struct timeval.
typedef struct timeval NXSoundStreamTime;

#define NX_SOUNDSTREAM_TIME_NULL ((struct timeval *)0)

@interface NXSoundStream:Object
{
    id			delegate;
    BOOL		_isActive;
    BOOL		_isPaused;
    id			_device;
    port_t		_streamPort;
    unsigned int	_delegateMessages;
    kern_return_t	_kernelError;
    NXSoundDeviceError	_lastError;
    int			_reserved;
}

// New in 3.1.
- initOnDevice:aDevice withParameters:(id <NXSoundParameters>)params;
- (id <NXSoundParameters>)parameters;

- init;
- initOnDevice:anObject;
- device;
- (NXSoundDeviceError)setDevice:anObject;
- (port_t)streamPort;
- (BOOL)isActive;
- (NXSoundDeviceError)activate;
- (NXSoundDeviceError)deactivate;
- (BOOL)isPaused;
- pause:sender;
- resume:sender;
- abort:sender;
- (NXSoundDeviceError)pauseAtTime:(struct timeval *)time;
- (NXSoundDeviceError)resumeAtTime:(struct timeval *)time;
- (NXSoundDeviceError)abortAtTime:(struct timeval *)time;
- (unsigned int)bytesProcessed;
- (NXSoundDeviceError)lastError;
- delegate;
- setDelegate:anObject;
- free;

@end

@interface Object(NXSoundStreamDelegate)
- soundStream:sender didStartBuffer:(int)tag;
- soundStream:sender didCompleteBuffer:(int)tag;
- soundStreamDidPause:sender;
- soundStreamDidResume:sender;
- soundStreamDidAbort:sender deviceReserved:(BOOL)flag;
@end
